clear all;
global svModel;
t1 = cputime;
%--------------------------------------------------

load ../database/usps_perm.mat
%[rien,train_labels] = max(train_labels,[],1);
%[rien,test_labels] = max(test_labels,[],1);
%train_labels(find((train_labels)==-1)) = 0;
%test_patterns(find((test_patterns)<0)) = 0;
%train_patterns = sparse(train_patterns);
%test_patterns = sparse(test_patterns);
train_patterns = (train_patterns-mean(train_patterns,2)*ones(1,size(train_patterns,2)))./...
    (std(train_patterns,[],2)*ones(1,size(train_patterns,2)));
test_patterns = (test_patterns-mean(test_patterns,2)*ones(1,size(test_patterns,2)))./...
    (std(test_patterns,[],2)*ones(1,size(test_patterns,2)));
donnees = data(train_patterns, train_labels, test_patterns, test_labels);
clear train_patterns;
clear train_labels;
clear test_patterns;
clear test_labels;
multiclass = '';
%-----------------------------------------------------
%   Learning Parameters
%C = .1;
%p = [4,exp(-4)];
C = 1;
p = 0.1;
ker= 'rbf';
tolerance = 1e-8;
pas = 100;
meth = 'chol';
parametres = param(C,pas,multiclass,meth,tolerance);
parametres.type='VO';
noyau = kernel(ker,p);
%-----------------------------------------------------
% Learning and testing 1vs1
trainSVM(donnees,noyau,parametres);
%svModel.model.alpha{1}
prediction = testSVM;
% perf = length(find(donnees.testlab==prediction(:,1)))/length(prediction);

[m,prediction] = max(prediction,[],2);
[m,test] = max(donnees.testlab,[],1);
perf = length(find(test'==prediction))/length(prediction);
fprintf(1,'performance en test: %2.2f \n',100*perf);
t2 = cputime-t1

