%close all
global svModel;
%--------------------------------------------------
%load('../database/wipo.mat');
VOwipo;
nbclass = 187;

%Y_tr(find(Y_tr==0))=-1;
%Y_ts(find(Y_ts==0))=-1;
donnees = data(X_tr',Y_tr',X_ts',Y_ts');
clear X_tr;
clear X_ts;
clear Y_tr;
clear Y_ts;
%-----------------------------------------------------
%   Learning and Learning Parameters
C = 0.01;
p = 2;
ker = 'rbf';
%p = [1,5];
%ker = 'poly';
noyau = kernel(ker,p);
tolerance = 1e-5;
pas = 100;
multiclass = '';
method='chol';
parametres = param(C,pas,multiclass,method,tolerance);
parametres.type='VO';

tic
trainSVM(donnees,noyau,parametres);
toc
tic
[ypred]=testSVM;
toc
% profview

[M,I] = max(ypred,[],2);

count = 0;
for i=1:size(svModel.data.testvec,2)
        perf = length(find(svModel.model.possibleoutputMatrix(:,I(i))+svModel.data.testlab(:,i)==2));
        if perf==3
            count = count+1;
        end
end
goodPaths = count
testRate = count*100/size(svModel.data.testvec,2)


svModel.data.testvec = svModel.data.trainvec;
svModel.data.testlab = svModel.data.trainlab;

tic
[ypred]=testSVM;
toc
% profview

[M,I] = max(ypred,[],2);

count = 0;
for i=1:size(svModel.data.testvec,2)
        perf = length(find(ceil(svModel.model.possibleoutputMatrix(:,I(i)))+ceil(svModel.data.testlab(:,i))==2));
        if perf==3
            count = count+1;
        end
end
goodPaths = count
trainRate = count*100/size(svModel.data.testvec,2)

