function boolean = isWellConstrained(alpha)

global svModel;
global temporarelyDataNeeded;

[min_alpha pos_alpha]=min(alpha{svModel.model.iclass}); 
[max_alpha pos_alpham]=max(alpha{svModel.model.iclass});
if strcmp(svModel.param.type,'nu')
     if ((min_alpha < 0 | max_alpha>1) & temporarelyDataNeeded.n_active> 3 )
        boolean = 0;
    else
        boolean = 1;
    end
else
    if ((sum(svModel.model.alpha{svModel.model.iclass}<0)>0 | ...
            sum(svModel.model.alpha{svModel.model.iclass}>svModel.param.C(temporarelyDataNeeded.active))>0) ...
            & temporarelyDataNeeded.n_active>3)
        boolean = 0;
    else
        boolean = 1;
    end
end