function  initialize % qr normal

global svModel;
global temporarelyDataNeeded;

if length(svModel.model.indices{svModel.model.iclass})<2
	temporarelyDataNeeded.active = sort( [min(find(svModel.data.trainlab==1));min(find(svModel.data.trainlab==-1))]);
else
	temporarelyDataNeeded.active = svModel.model.indices{svModel.model.iclass};
	disp('takes previously selected points');
end

temporarelyDataNeeded.nb_test = 0;
temporarelyDataNeeded.j = 0;
temporarelyDataNeeded.nb_boucle = 0;
temporarelyDataNeeded.n = length(svModel.data.trainlab);
temporarelyDataNeeded.objectif=0;
temporarelyDataNeeded.lbase = 500;
if length(temporarelyDataNeeded.active)>500
    temporarelyDataNeeded.lbase = length(temporarelyDataNeeded.active)+100;
end
temporarelyDataNeeded.lpas = 250;
if length(svModel.param.C)==1
	svModel.param.C = svModel.param.C*ones(temporarelyDataNeeded.n,1);
end
svModel.model.G{svModel.model.iclass} = zeros(temporarelyDataNeeded.lbase,temporarelyDataNeeded.lbase);
svModel.model.G1{svModel.model.iclass} = zeros(temporarelyDataNeeded.lbase,temporarelyDataNeeded.lbase);
svModel.model.G2{svModel.model.iclass} = zeros(temporarelyDataNeeded.lbase,temporarelyDataNeeded.lbase);
temporarelyDataNeeded.n_H = [1:length(temporarelyDataNeeded.active)];
temporarelyDataNeeded.n_Ha = [1:length(temporarelyDataNeeded.active)];  
[svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H), svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)]=...
    qr(kernelPol(svModel.kernel,...
    svModel.data.trainvec(:,temporarelyDataNeeded.active), ...
    svModel.data.trainvec(:,temporarelyDataNeeded.active), ...
    svModel.data.trainlab(temporarelyDataNeeded.active), ...
    svModel.data.trainlab(temporarelyDataNeeded.active)));
temporarelyDataNeeded.x = svModel.param.C(temporarelyDataNeeded.active)/2.*ones(length(temporarelyDataNeeded.active),1);

% conditionment
 %svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H) = ...
 %         svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)+ svModel.param.gap*eye(length(temporarelyDataNeeded.n_H));
svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H) = ...
          svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)+ svModel.param.gap*eye(length(temporarelyDataNeeded.n_H));
      

if length(temporarelyDataNeeded.active)>1
    ce = ones(1,length(temporarelyDataNeeded.active));
    % initialize the first solution in the box
    M = svModel.data.trainlab(temporarelyDataNeeded.active)'*...
    (svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)\...
    (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)'*...
    svModel.data.trainlab(temporarelyDataNeeded.active)));
    
    svModel.model.mu{svModel.model.iclass} =...
     M\(svModel.data.trainlab(temporarelyDataNeeded.active)'*...
     (svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)\...
    (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)'*ce')));
    
    svModel.model.alpha{svModel.model.iclass}=...
    svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)\...
        svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)'*...
	(ce'-svModel.data.trainlab(temporarelyDataNeeded.active)*...
	svModel.model.mu{svModel.model.iclass});
    
%      dir = svModel.model.alpha{svModel.model.iclass} - temporarelyDataNeeded.x;                % projection direction
%      indad = find(svModel.model.alpha{svModel.model.iclass} < 0);
%      indsup = find(svModel.model.alpha{svModel.model.iclass} > svModel.param.C(temporarelyDataNeeded.active));
%      [tI indmin] = min(-temporarelyDataNeeded.x(indad)./dir(indad));
%      [tS indS] = min((svModel.param.C(temporarelyDataNeeded.active(indsup))-temporarelyDataNeeded.x(indsup))./dir(indsup)); % descent step 
%      if isempty(tI) , tI = tS + 1; end; 
%      if isempty(tS) , tS = tI + 1; end; 
%      t = min(tI,tS); 
%      if isempty(t)
%          temporarelyDataNeeded.x = svModel.model.alpha{svModel.model.iclass};
%      else
%          temporarelyDataNeeded.x = temporarelyDataNeeded.x + t*dir;   
%      end
%      
%      temporarelyDataNeeded.inactive = sort([setdiff([1:length(svModel.data.trainlab)],temporarelyDataNeeded.active),temporarelyDataNeeded.active(find(svModel.model.alpha{svModel.model.iclass}<0))']);
%      temporarelyDataNeeded.bounded = sort(temporarelyDataNeeded.active(find(svModel.model.alpha{svModel.model.iclass}>svModel.param.C(temporarelyDataNeeded.active))));
%      [temporarelyDataNeeded.active,svModel.model.indices{svModel.model.iclass}] = sort(temporarelyDataNeeded.active(find((0<=svModel.model.alpha{svModel.model.iclass})&...
%          (svModel.model.alpha{svModel.model.iclass}<=svModel.param.C(temporarelyDataNeeded.active)))));
%      temporarelyDataNeeded.x = temporarelyDataNeeded.x(svModel.model.indices{svModel.model.iclass});
    
end
    temporarelyDataNeeded.bounded = [];
    temporarelyDataNeeded.inactive = setdiff([1:length(svModel.data.trainlab)],[temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]);

temporarelyDataNeeded.free(1) = length(temporarelyDataNeeded.active)+1;
temporarelyDataNeeded.relative = zeros(1,temporarelyDataNeeded.n);
temporarelyDataNeeded.relative(temporarelyDataNeeded.active) = temporarelyDataNeeded.n_H;
temporarelyDataNeeded.inverse = temporarelyDataNeeded.n_H;
temporarelyDataNeeded.reverse = temporarelyDataNeeded.n_H;
temporarelyDataNeeded.new_active = [];
temporarelyDataNeeded.n_inactive=length(temporarelyDataNeeded.inactive);
temporarelyDataNeeded.n_active=length(temporarelyDataNeeded.active);
temporarelyDataNeeded.n_bounded=length(temporarelyDataNeeded.bounded);

temporarelyDataNeeded.bhist0 = zeros(1,temporarelyDataNeeded.n);
%temporarelyDataNeeded.bhistC = zeros(1,temporarelyDataNeeded.n);
temporarelyDataNeeded.bloc0 = [];
%temporarelyDataNeeded.blocC = [];
temporarelyDataNeeded.boundedback = 0;