function solveLinearSystem

global svModel;
global temporarelyDataNeeded;
% calculer le noyau
%===================================================================
if temporarelyDataNeeded.new_active>0 % on a ajout un point
      
      % mise  jour des indices
      temporarelyDataNeeded.n_H = sort([temporarelyDataNeeded.n_H,temporarelyDataNeeded.free(1)]);
      temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active) = temporarelyDataNeeded.free(1);
      temporarelyDataNeeded.inverse = temporarelyDataNeeded.relative(temporarelyDataNeeded.active);
      [temp, temporarelyDataNeeded.reverse] = sort(temporarelyDataNeeded.inverse);
      if max(temporarelyDataNeeded.inverse)>length(temporarelyDataNeeded.inverse)
            [temp, temporarelyDataNeeded.inverse] = sort(temporarelyDataNeeded.reverse);
      end
      % calcul des nouvelles valeurs de H
      new_valueH =kernelPol(svModel.kernel,...
            svModel.data.trainvec(:,temporarelyDataNeeded.active), ...
            svModel.data.trainvec(:,temporarelyDataNeeded.new_active), ...
            svModel.data.trainlab(temporarelyDataNeeded.active), ...
            svModel.data.trainlab(temporarelyDataNeeded.new_active)); % points dans l'ordre des donnees, donc de actif
      % valeurs pour G
      u = new_valueH(temporarelyDataNeeded.reverse);
      %u(temporarelyDataNeeded.free(1)) = u(temporarelyDataNeeded.free(1))+svModel.param.gap;
      sv_qrup(u,u,temporarelyDataNeeded.free(1),0);
           
      % derniere mise  jours
      temporarelyDataNeeded.free(1) = [];
      if isempty(temporarelyDataNeeded.free)
            temporarelyDataNeeded.free = temporarelyDataNeeded.n_active+1;
      end
      
elseif temporarelyDataNeeded.new_active<0 % on a retir un point
      temp1 = [temporarelyDataNeeded.active; -temporarelyDataNeeded.new_active];
      [temp2,temp] = sort(temporarelyDataNeeded.relative(temp1));
      temp = temp1(temp);
      remove = find(temporarelyDataNeeded.n_H==temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)); % place du point  enlever dans nH
      new_valueH = svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.relative(temp),:)*...
      svModel.model.G2{svModel.model.iclass}(:,temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active));
      u = -new_valueH;
      % suppression des valeurs dans Q et R
     sv_qrup(u,u,remove,1);
     
     svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)) = 0;
     svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active),temporarelyDataNeeded.n_H) = 0;
     svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)) = 0;
     svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active),temporarelyDataNeeded.n_H) = 0;
            
      % mise  jours des indices
      temporarelyDataNeeded.free = sort([temporarelyDataNeeded.free,temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)]);
      remove = find(temporarelyDataNeeded.n_H==temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active));
      temporarelyDataNeeded.n_H(remove)=[];            
      temporarelyDataNeeded.inverse = temporarelyDataNeeded.relative(temporarelyDataNeeded.active);
      [temp, temporarelyDataNeeded.reverse] = sort(temporarelyDataNeeded.inverse);
      if max(temporarelyDataNeeded.inverse)>length(temporarelyDataNeeded.inverse)
            [temp, temporarelyDataNeeded.inverse] = sort(temporarelyDataNeeded.reverse);
      end
      temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active) = 0;
end

% mettre les elements dans l'ordre de H!!
if length(svModel.param.span)>0
    A = (svModel.data.trainlab(temporarelyDataNeeded.active)*ones(1,temporarelyDataNeeded.n_active))*svModel.param.span(temporarelyDataNeeded.active,:);
    be = zeros(size(svModel.param.span,2),1);
    A = A(temporarelyDataNeeded.reverse,:);
else
    A = svModel.data.trainlab(temporarelyDataNeeded.active);
    A = A(temporarelyDataNeeded.reverse);
    be = 0;
end
ce = ones(1,temporarelyDataNeeded.n_active);
if temporarelyDataNeeded.n_bounded > 0            
      new_valueH = kernelPol(svModel.kernel,...
            svModel.data.trainvec(:,temporarelyDataNeeded.active), ...
            svModel.data.trainvec(:,temporarelyDataNeeded.bounded), ...
            svModel.data.trainlab(temporarelyDataNeeded.active), ...
            svModel.data.trainlab(temporarelyDataNeeded.bounded)); % points dans l'ordre des donnees, donc de actif
      ce= ce - max(svModel.param.C)*(sum(new_valueH,2))';
      be= be - max(svModel.param.C)*sum(svModel.data.trainlab(temporarelyDataNeeded.bounded),1); 
end
ce = ce(temporarelyDataNeeded.reverse);

%  if rcond(svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H))<-svModel.param.gap
%  	svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H) =...
%  	svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)-...
%  	2*svModel.param.gap*...
%  	eye(size(svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)));
%  end

M = A'*(svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)\...
    (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)'*...
    A));
N = A'*(svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)\...
    (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)'*...
    ce'));
O = ce*(svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)\...
    (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)'*...
    A));
%P = ce*(svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)\...
%    (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)'*...
%    ce'));
svModel.model.mu{svModel.model.iclass} = svModel.param.nu/(M-O);
svModel.model.gamma{svModel.model.iclass} = (svModel.model.mu{svModel.model.iclass}*M)/(N*(M-0));
svModel.model.alpha{svModel.model.iclass} = ...
	svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)\...
	svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)'*...
	(svModel.model.gamma{svModel.model.iclass}*ce'-A*svModel.model.mu{svModel.model.iclass});

%D = [svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)*...
%        svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H),A,ce';A',0,0;ce,0,0];
%beta = D\[zeros(temporarelyDataNeeded.n_active,1);0;svModel.param.nu];
%svModel.model.alpha{svModel.model.iclass} = beta(1:temporarelyDataNeeded.n_active);
%svModel.model.mu{svModel.model.iclass} = beta(temporarelyDataNeeded.n_active+1);
%svModel.model.gamma{svModel.model.iclass} = -beta(temporarelyDataNeeded.n_active+2);

% 
% M = A'*(svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)\...
%     (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)'*...
%     A));
% svModel.model.mu{svModel.model.iclass} = M\(A'*(svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)\...
%     (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)'*ce'))-be);
% svModel.model.alpha{svModel.model.iclass}=...
% svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)\... 
%     svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)'*...
%     (ce'-A*svModel.model.mu{svModel.model.iclass});

% remettre alpha dans l'ordre de l'active set
svModel.model.alpha{svModel.model.iclass} = svModel.model.alpha{svModel.model.iclass}(temporarelyDataNeeded.inverse);