function [t] = transformer(x,s)

[n,d] = size(x);
t = [];
if length(s)>1
    transfo = s;
else
    transfo = round(rand(s,1)*8);
end
for si = 1:length(transfo)
      % transfo = ceil(rand(1,1)*13);
      switch transfo(si)
            case 1
                  coor = [1; 2];
                  t = translater(x,n,coor,t);
            case 2
                  coor = [2,1];
                  t = translater(x,n,coor,t);
            case 3
                  coor = [2,3];
                  t = translater(x,n,coor,t);
            case 4
                  coor = [3,2];
                  t = translater(x,n,coor,t);
            case 5
                  coor = [1,1];
                  t = translater(x,n,coor,t);
            case 6
                  coor = [1,3];
                  t = translater(x,n,coor,t);
            case 7
                  coor = [3,3];
                  t = translater(x,n,coor,t);
            case 8
                  coor = [3,1]; 
                  t = translater(x,n,coor,t);
            case 9
                  b = reshape(imrotate(reshape((x+1)/2,sqrt(n),sqrt(n)),-10,'nearest','crop'),n,1);
                  t = [t,(b*2)-1];            
            case 10
                  b = reshape(imrotate(reshape((x+1)/2,sqrt(n),sqrt(n)),10,'nearest','crop'),n,1);
                  t = [t,(b*2)-1];           
            case 11
                  b = reshape(imrotate(reshape((x+1)/2,sqrt(n),sqrt(n)),-5,'nearest','crop'),n,1);
                  t = [t,(b*2)-1];            
            case 12
                  b = reshape(imrotate(reshape((x+1)/2,sqrt(n),sqrt(n)),5,'nearest','crop'),n,1);
                  t = [t,(b*2)-1];
                  %       case 'couleur'
                  %             prop_inf = param(1);
                  %             prop_sup = param(2);
                  %             pas = param(3);
                  %             prop = [prop_inf:pas:prop_sup];
                  %             for i=prop
                  %                   t = [t, x+(i.*x)];
                  %                   t(find(t>1))=1;
                  %                   t(find(t<-1))=-1;
                  %             end
            case 13
                  se = strel('disk',1);
                  a = reshape(x,sqrt(n),sqrt(n));
                  a = imerode(a,se);
                  t = [t, reshape(a,n,1)];
            case 14
                  se = strel('disk',1);
                  a = reshape(x,sqrt(n),sqrt(n));
                  a = imdilate(a,se);
                  t = [t, reshape(a,n,1)];
      end
end

function [t] = translater(x,n,coor,t)

a = reshape(x,sqrt(n),sqrt(n));
dim = sqrt(n)-1;
b = min(x)*ones(dim+3,dim+3);
b(2:dim+2,2:dim+2) = a;
c = b(coor(1):coor(1)+dim,coor(2):coor(2)+dim);
t = [t,reshape(c,n,1)];