global svModel;
global temporarelyDataNeeded;

A = randn(5,5);
temporarelyDataNeeded.n_H = 1:5;
%B = A;
B = A'*A;
svModel.model.iclass=1;
svModel.param.gap = 10^-5;
u = B(:,5);
v = B(5,:);
B(:,5)=0;
B(5,:)=0;

% qr update
[svModel.model.G1{1}(1:5,1:5),svModel.model.G2{1}(1:5,1:5)] = qr(B);
sv_qrup(u,v',5,0);

C = svModel.model.G1{1}(1:5,1:5)*...
svModel.model.G2{1}(1:5,1:5);
B-C

% shmo
svModel.model.G1{1}(1:4,1:4) = inv(B(1:4,1:4));
svModel.model.G1{1}(:,5) =0;
svModel.model.G1{1}(5,:) =0;
sherman_morrison(5,u);

D = inv(svModel.model.G1{1}(1:5,1:5));
B-D

% chol
B(:,5) = u;
B(5,:) =v;
[svModel.model.G1{1}(1:5,1:5)] = chol(B);
G = svModel.model.G1{1}(1:5,1:5)'*...
svModel.model.G1{1}(1:5,1:5);
B-G



% enlever maintenant

% qr update
[svModel.model.G1{1}(1:5,1:5),svModel.model.G2{1}(1:5,1:5)] = qr(B);

sv_qrup(-u,-v',5,1);

E = svModel.model.G1{1}(1:5,1:5)*...
svModel.model.G2{1}(1:5,1:5);
B(1:4,1:4)-E(1:4,1:4)

% shmo
svModel.model.G1{1}(1:5,1:5) = inv(B);
sherman_morrison(5,-u);

F = inv(svModel.model.G1{1}(1:5,1:5));
B(1:4,1:4)-F(1:4,1:4)