%function test1class

nbapp = 100;
nbtest = 100;
global svModel;
%--------------------------------------------------
x = [];
xt =  [0.1*randn(2,nbtest/2), .1+0.15*randn(2,nbtest/2)];
y = [];
yt =  [ones(nbtest/2,1); -ones(nbtest/2,1)];
donnees = data(x,y,xt,yt);
multiclass='1class';


%-----------------------------------------------------
%   Learning Parameters
C = 1000;
p = [100];
ker= 'rbf';
tolerance = 1e-5;
pas = 10;
parametres = param(C,pas,multiclass,'chol',tolerance);
noyau = kernel(ker,p);
[xtesta1,xtesta2]=meshgrid([-.5:0.01:1],[-.5:0.01:1]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2];

couleur = ['k','b','c','m','r','y','g'];
forme = ['x','v','p','+','x','<','>'];
nbapp = [1,100, 20,20,50,20, 10, 100, 100];
for etape = 1:4
    %-----------------------------------------------------
    % Learning and testing
    x = 0.03*randn(2,nbapp(etape+1));
    donnees.trainlab = [ones(nbapp(etape+1),1)];
    donnees.trainvec = [x+(0.03*etape)];
    trainSVM(donnees,noyau,parametres);
    svModel.data.testvec = xtest;
    ypred = testSVM;
    ypredmat=reshape(ypred,na,nb);
    hold on
    [cs,h]=contour(xtesta1,xtesta2,ypredmat,[0 1],couleur(etape));
    %clabel(cs,h);
    %plot(donnees.trainvec(1,sum(nbapp(1:etape))+1:end),donnees.trainvec(2,sum(nbapp(1:etape))+1:end),[couleur(etape),forme(etape)]);
    plot(donnees.trainvec(1,:),donnees.trainvec(2,:),[couleur(etape),forme(etape)]);
    % hold on;
    plot(donnees.trainvec(1,svModel.model.indices{1}),donnees.trainvec(2,svModel.model.indices{1}),[couleur(etape),'o']);
    %plot(donnees.testvec(1,find(donnees.testlab==-1)),donnees.testvec(2,find(donnees.testlab==-1)),'ro');
    %plot(donnees.testvec(1,find(donnees.testlab==1)),donnees.testvec(2,find(donnees.testlab==1)),'go');
    %plot(donnees.testvec(1,find(sign(prediction)==-1)),donnees.testvec(2,find(sign(prediction)==-1)),'rx');
    %plot(donnees.testvec(1,find(sign(prediction)==1)),donnees.testvec(2,fi
    %nd(sign(prediction)==1)),'gx');
end

legend('support lines','learning data','support vectors',0);%'not in the classe','in the class',0);
title('One Class SVM');
hold off;



