%
%  SVM Classification 2D examples
%  with different penalization settings
%
%  05/05/03 AR



close all
n = 50; 
sigma=0.5;
% kernel
k = kernel('rbf',1);
% data
d = data;
[d.trainvec,d.trainlab,d.testvec,d.testlab] = dataset('gaussian',n,10,sigma);
% svm
sv = svm(k,d);
Cpos=1000; %  assymetric C 
Cneg=inf;
sv.param.C=Cpos*(sv.data.trainlab==1)+Cneg*(sv.data.trainlab==-1);
sv.param.step = 10;
sv.param.method = 'chol';
% train
[sv] = SvmTrain(sv);


% %------- Building a 2D Grid for function evaluation -------------------------
% [xtest1 xtest2]  = meshgrid([-1:.05:1]*3.5,[-1:0.05:1]*3); 
% nn = length(xtest1); 
% Xtest = [reshape(xtest1 ,nn*nn,1) reshape(xtest2 ,nn*nn,1)]; 
% 
% %--------------  Evaluating the decision function
% [ypred] = OnLineSVM_val(d,alpha,pos,nbsv,b,[],Xtest');
% ypred = reshape(ypred,nn,nn); 
%  
% 
% %--------------- plotting
% figure(1); 
% clf; 
% contourf(xtest1,xtest2,ypred,50);shading flat;
% hold on
% [cc,hh]=contour(xtest1,xtest2,ypred,[-1  0 1],'k');
% clabel(cc,hh); 
% h1=plot(vector_training_set(1,label_training_set==1),vector_training_set(2,label_training_set==1),'+r'); 
% set(h1,'LineWidth',2);
% 
% h2=plot(vector_training_set(1,label_training_set==-1),vector_training_set(2,label_training_set==-1),'db'); 
% set(h2,'LineWidth',2);
% h3=plot(vector_training_set(1,pos),vector_training_set(2,pos),'ok'); 
% set(h3,'LineWidth',2);


 

