clear all;
global svModel;
t1 = cputime;
%--------------------------------------------------

[train_patterns, vide] = readidx('../database/mnist/train-images-idx3-ubyte',60000,60000);
[train_labels, vide] = readidx('../database/mnist/train-labels-idx1-ubyte',60000,60000);
[test_patterns, vide] = readidx('../database/mnist/t10k-images-idx3-ubyte',10000,10000);
[test_labels, vide] = readidx('../database/mnist/t10k-labels-idx1-ubyte',10000,10000);

fprintf('Les donnes sont lues\n');
% for i=1:784
%       test_patterns(i,:) = (test_patterns(i,:)./128)-1;
%       train_patterns(i,:) = (train_patterns(i,:)./128)-1;
% end
% fprintf('Les donnes sont normalises\n');
%  % supprimer le cadre blanc
%  ad = [];
%  b = 2;
%  a = b*28;
%  for i = 1:28-2*b
%        ad = [ad,a+b+1:a+28-b];
%        a = a+28;
%  end
%  train_patterns = train_patterns(ad,:);  
%  test_patterns = test_patterns(ad,:);

profile on;
train_labels(find(train_labels<5)) = -1;
train_labels(find(train_labels>=5)) = 1;
test_labels(find(test_labels<5)) = -1;
test_labels(find(test_labels>=5)) = 1;
donnees = data(train_patterns, train_labels', test_patterns, test_labels');
clear train_patterns;
clear train_labels;
clear test_patterns;
clear test_labels;
multiclass = '';
%-----------------------------------------------------
%   Learning Parameters
C = 50;
p = [1/(2*3500*3500)];
ker= 'rbf';
tolerance = 1e-7;
pas = 100;
meth = 'qr';
parametres = param(C,pas,multiclass,meth,tolerance);
parametres.sizecache=100;
noyau = kernel(ker,p);
%-----------------------------------------------------
% tic;
% chunkingSVM(donnees, noyau, parametres,10000);
% toc
% Learning and testing 1vs1
fprintf('Je rentre dans le SVM\n');
trainSVM(donnees,noyau,parametres);
clear donnees;
prediction = testSVM;
perf = length(find(svModel.data.testlab==sign(prediction)))/length(prediction);
fprintf(1,'performance en test: %2.2f \n',100*perf);
profview
t2 = cputime-t1

