% kernelcache

% 

function [f] = kernelcache(ind1,ind2)
global svModel;

is = mod(7755989*ind1,svModel.model.linecache)+1; % for SV
js = mod(91159*ind2,svModel.model.columncache)+1; % for others

for i = 1:length(ind1)
    for j=1:length(ind2)
        if (svModel.model.cache{2}(is(i),js(j)) == ind1(i) & svModel.model.cache{3}(is(i),js(j)) == ind2(j))
            f(i,j) = svModel.model.cache{1}(is(i),js(j));
        else
            f(i,j) = kernelPol(svModel.kernel,svModel.data.trainvec(:,ind1(i)),...
                svModel.data.trainvec(:,ind2(j)),...
                svModel.data.trainlab(ind1(i)),...
                svModel.data.trainlab(ind2(j)));
            svModel.model.cache{1}(is(i),js(j)) = f(i,j);
            svModel.model.cache{2}(is(i),js(j)) = ind1(i);
            svModel.model.cache{3}(is(i),js(j)) = ind2(j);
        end
    end
end


function [flg] = coupleexists(i,j)
global svModel;
[a,inda] = find(svModel.model.cached(1,:)==i);
if length(a)>0
    if length(find(svModel.model.cached(2,inda)==j))>0
        flg = 0;
    else
        flg = 1;
    end
else 
    flg = 1;
end
    