function [bestP, bestC, bestO, maxPerf, performance] = leaveOneOut(dataset,svmParameters, svmKernel, parameters, slacks, orders)

global svModel;



n = length(dataset.trainlab);
no = 0;
for o = orders
    no = no+1;
    np = 0;
    svmKernel.degree = o;
    for p = parameters
        np = np+1;
        svmKernel.scale = p;
        svmKernel.sigma = p;
        nc = 0;
        for c = slacks
            nc = nc+1;
            svmParameters.C = c;
            for i = 1:n
                if svmParameters.verbose > 0
                    fprintf('%d : ',i);
                end
                donnees.trainvec = dataset.trainvec(:,[1:(i-1),(i+1):n]);
                donnees.trainlab = dataset.trainlab([1:(i-1),(i+1):n]);
                donnees.testvec = dataset.trainvec(:,i);
                donnees.testlab = dataset.trainlab(i);
                if i>1
                    trainSVM(donnees, svmKernel, svmParameters, svModel.model);
                else
                    trainSVM(donnees, svmKernel, svmParameters);
                end
                prediction=testSVM;
                perf(no,np,nc,i) = max(length(find(sign(svModel.data.testlab)==sign(prediction(:,1))))/length(prediction(:,1)),length(find(svModel.data.testlab==prediction(:,1)))/length(prediction(:,1)));
            end
        end
    end
end

svModel.data = dataset;

k = 0;
maxPerf = 0;
for o = 1:no
    for p = 1:np
        for c = 1:nc
            k = k+1;
            performance(k) = mean(perf(o,p,c,:));
            if performance(k)>maxPerf
                maxPerf = performance(k);
                bestP = parameters(p);
                bestC = slacks(c);
                bestO = orders(o);
            end
        end
    end
end