function projectSolutionNu

global svModel;
global temporarelyDataNeeded;

dir = svModel.model.alpha{svModel.model.iclass} - temporarelyDataNeeded.x;                % projection direction
indad = find(svModel.model.alpha{svModel.model.iclass} < 0);
indsup = find(svModel.model.alpha{svModel.model.iclass} > 1);
[tI indmin] = min(-temporarelyDataNeeded.x(indad)./dir(indad));
[tS indS] = min((svModel.param.C(temporarelyDataNeeded.active(indsup))-temporarelyDataNeeded.x(indsup))./dir(indsup)); % descent step 
if isempty(tI) , tI = tS + 1; end; 
if isempty(tS) , tS = tI + 1; end; 
t = min(tI,tS); 
if isempty(t)
    temporarelyDataNeeded.new_active = 0;
elseif t==tI
temporarelyDataNeeded.x = temporarelyDataNeeded.x + t*dir; % projection into the admissible set
      temporarelyDataNeeded.new_active = -temporarelyDataNeeded.active(indad(indmin));
      if (strcmp(svModel.param.type, 'invariant') & temporarelyDataNeeded.active(indad(indmin))<=length(svModel.data.trainlab_t))
          temporarelyDataNeeded.inactive = sort([temporarelyDataNeeded.inactive , temporarelyDataNeeded.active(indad(indmin))]); % the point is taken off the active set to the inactive set
      else
          temporarelyDataNeeded.inactive = sort([temporarelyDataNeeded.inactive , temporarelyDataNeeded.active(indad(indmin))]); % the point is taken off the active set to the inactive set
      end
      temporarelyDataNeeded.active(indad(indmin)) = [];            % the associate temporarelyDataNeedediable is set to 0
      temporarelyDataNeeded.x(indad(indmin)) = []; 
else 
temporarelyDataNeeded.x = temporarelyDataNeeded.x + t*dir; % projection into the admissible set
      temporarelyDataNeeded.bounded = sort([temporarelyDataNeeded.bounded ; temporarelyDataNeeded.active(indsup(indS))]); % the point is taken off the active set to the bounded set
      temporarelyDataNeeded.new_active = -temporarelyDataNeeded.active(indsup(indS));
      temporarelyDataNeeded.active(indsup(indS))= [];              % the associate temporarelyDataNeedediable is set to 0
      temporarelyDataNeeded.x(indsup(indS))= [];
end

temporarelyDataNeeded.new_active