function solveLinearSystem % qrupdate

global svModel;
global temporarelyDataNeeded;
%temporarelyDataNeeded.new_active
% calculer le noyau
%===================================================================

if temporarelyDataNeeded.new_active>0 % on a ajoute un point
    if temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active)==0 % n'est pas un point qui revient de C
        % mise a jour des indices
        temporarelyDataNeeded.n_H = sort([temporarelyDataNeeded.n_H,temporarelyDataNeeded.free(1)]);
        temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active) = temporarelyDataNeeded.free(1);
        temporarelyDataNeeded.inverse = temporarelyDataNeeded.relative([temporarelyDataNeeded.active;...
            temporarelyDataNeeded.bounded]);
        [temp, temporarelyDataNeeded.reverse] = sort(temporarelyDataNeeded.inverse);
        if max(temporarelyDataNeeded.inverse)>length(temporarelyDataNeeded.inverse)
            [temp, temporarelyDataNeeded.inverse] = sort(temporarelyDataNeeded.reverse);
        end
        % calcul des nouvelles valeurs de H
        new_valueH =kernelPol(svModel.kernel,...
            svModel.data.trainvec(:,[temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]), ...
            svModel.data.trainvec(:,temporarelyDataNeeded.new_active), ...
            svModel.data.trainlab([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]), ...
            svModel.data.trainlab(temporarelyDataNeeded.new_active)); % points dans l'ordre des donnees, donc de actif



        % repartition des valeurs du noyau entre les libres et les bornes
        temporarelyDataNeeded.n_Ha = sort(temporarelyDataNeeded.relative(temporarelyDataNeeded.active));
        temporarelyDataNeeded.n_Hb = sort(temporarelyDataNeeded.relative(temporarelyDataNeeded.bounded));
        % valeurs pour G
        u = new_valueH(temporarelyDataNeeded.reverse);
        svModel.model.G{svModel.model.iclass}(temporarelyDataNeeded.n_H,...
            temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active)) = u;
        svModel.model.G{svModel.model.iclass}(temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active),...
            temporarelyDataNeeded.n_H) = u';
        u = svModel.model.G{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,...
            temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active));
%         [a b c] = intersect(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_Hb);
%         u(b) = [];
        ind = find(temporarelyDataNeeded.n_Ha==temporarelyDataNeeded.free(1));
        %u(ind) = u(ind)+svModel.param.gap;
        sv_qrup2(u,u,ind,0);

        % derniere mise a jour
        temporarelyDataNeeded.free(1) = [];
        if isempty(temporarelyDataNeeded.free)
            temporarelyDataNeeded.free = max(temporarelyDataNeeded.n_H)+1;
        end
    else
        temporarelyDataNeeded.inverse = temporarelyDataNeeded.relative([temporarelyDataNeeded.active;...
            temporarelyDataNeeded.bounded]);
        [temp, temporarelyDataNeeded.reverse] = sort(temporarelyDataNeeded.inverse);
        if max(temporarelyDataNeeded.inverse)>length(temporarelyDataNeeded.inverse)
            [temp, temporarelyDataNeeded.inverse] = sort(temporarelyDataNeeded.reverse);
        end
%         temporarelyDataNeeded.n_Ha = sort(temporarelyDataNeeded.n_H(temporarelyDataNeeded.inverse...
%             (1:length(temporarelyDataNeeded.active))));
%         temporarelyDataNeeded.n_Hb = sort(temporarelyDataNeeded.n_H(temporarelyDataNeeded.inverse...
%             (end-length(temporarelyDataNeeded.bounded)+1:end)));
        temporarelyDataNeeded.n_Ha = sort(temporarelyDataNeeded.relative(temporarelyDataNeeded.active));
        temporarelyDataNeeded.n_Hb = sort(temporarelyDataNeeded.relative(temporarelyDataNeeded.bounded));
        temporarelyDataNeeded.boundedback=0;
        
        u = svModel.model.G{svModel.model.iclass}(temporarelyDataNeeded.n_H,...
            temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active));

        [a b c] = intersect(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_Ha);
        u = u(b);
        ind = find(temporarelyDataNeeded.n_Ha==temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active));
        %u(ind) = u(ind)+svModel.param.gap;
        sv_qrup2(u,u,ind,0);
        
    end

elseif temporarelyDataNeeded.new_active<0
    
   % temp = sort([temporarelyDataNeeded.active; -temporarelyDataNeeded.new_active]);
    remove = find(temporarelyDataNeeded.n_H==temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)); % place du point � enlever dans nH
    u = -svModel.model.G{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,...
        temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active));


    % suppression des valeurs dans Q et R
    remova = find(temporarelyDataNeeded.n_Ha==temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)); % place du point � enlever dans nH
    u(remova) = u(remova)+svModel.param.gap;
    sv_qrup2(u,u,remova,1);
     % suppression des valeurs
    svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,...
        temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)) = 0;
    svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active),...
        temporarelyDataNeeded.n_H) = 0;
    svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,...
        temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)) = 0;
    svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active),...
        temporarelyDataNeeded.n_H) = 0;
   
     
    if length(find(temporarelyDataNeeded.inactive==-temporarelyDataNeeded.new_active))>0 % on a retir� un point

   
        svModel.model.G{svModel.model.iclass}(temporarelyDataNeeded.n_H,...
            temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)) = 0;
        svModel.model.G{svModel.model.iclass}(temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active),...
            temporarelyDataNeeded.n_H) = 0;
        temporarelyDataNeeded.free = sort([temporarelyDataNeeded.free,...
            temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)]);
        temporarelyDataNeeded.n_H(remove)=[];
        temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active) = 0;
    
    end
    % mise a jours des indices
    temporarelyDataNeeded.inverse = temporarelyDataNeeded.relative([temporarelyDataNeeded.active;...
        temporarelyDataNeeded.bounded]);
    [temp, temporarelyDataNeeded.reverse] = sort(temporarelyDataNeeded.inverse);
    if max(temporarelyDataNeeded.inverse)>length(temporarelyDataNeeded.inverse)
        [temp, temporarelyDataNeeded.inverse] = sort(temporarelyDataNeeded.reverse);
    end
    % repartition des valeurs du noyau entre les libres et les bornes
        temporarelyDataNeeded.n_Ha = sort(temporarelyDataNeeded.relative(temporarelyDataNeeded.active));
        temporarelyDataNeeded.n_Hb = sort(temporarelyDataNeeded.relative(temporarelyDataNeeded.bounded));
%     temporarelyDataNeeded.n_Ha = sort(temporarelyDataNeeded.n_H(temporarelyDataNeeded.inverse...
%         (1:length(temporarelyDataNeeded.active))));
%     temporarelyDataNeeded.n_Hb = sort(temporarelyDataNeeded.n_H(temporarelyDataNeeded.inverse...
%         (end-length(temporarelyDataNeeded.bounded)+1:end)));


    

end
%rcond(svModel.model.G{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)) 


% mettre les elements dans l'ordre de H!!
if length(svModel.param.span)>0
    A = (svModel.data.trainlab(temporarelyDataNeeded.active)*ones(1,temporarelyDataNeeded.n_active))*svModel.param.span(temporarelyDataNeeded.active,:);
    be = zeros(size(svModel.param.span,2),1);
    A = A(temporarelyDataNeeded.reverse(temporarelyDataNeeded.inverse(1:temporarelyDataNeeded.n_active),:));
else
    A = svModel.data.trainlab([temporarelyDataNeeded.active]);%; temporarelyDataNeeded.bounded]);
    [a b] = sort(temporarelyDataNeeded.inverse(1:temporarelyDataNeeded.n_active));
    A = A(b);
    be = 0;
end



ce = ones(1,temporarelyDataNeeded.n_active);
if temporarelyDataNeeded.n_bounded > 0
    ce= ce - svModel.param.C(temporarelyDataNeeded.bounded)'*...
        (svModel.model.G{svModel.model.iclass}(temporarelyDataNeeded.n_Hb,temporarelyDataNeeded.n_Ha));
    be= be - svModel.param.C(temporarelyDataNeeded.bounded)'*svModel.data.trainlab(temporarelyDataNeeded.bounded);

end

M = A'*(svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)\...
    (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)'*A));
svModel.model.mu{svModel.model.iclass} = M\(A'*...
    (svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)\...
    (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)'*ce')) - be);
svModel.model.alpha{svModel.model.iclass}=...
    svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)\...
    (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)'*...
    (ce'-A*svModel.model.mu{svModel.model.iclass}));


% N = svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)\...
%     (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)'*ce');
% M = svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)\...
%     (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_Ha,temporarelyDataNeeded.n_Ha)'*A);
% svModel.model.mu{svModel.model.iclass} = (A'*N-be)/(A'*M);
% svModel.model.alpha{svModel.model.iclass} = N- svModel.model.mu{svModel.model.iclass}*M;

% remettre alpha dans l'ordre de l'active set
[a b] = sort(temporarelyDataNeeded.inverse(1:temporarelyDataNeeded.n_active));
[c d] = sort(b);
svModel.model.alpha{svModel.model.iclass} = ...
    svModel.model.alpha{svModel.model.iclass}(d);
%svModel.model.alpha{svModel.model.iclass}'
%temporarelyDataNeeded.new_active



